#version 330 core
#define y60 0.8660254

in FragIn {
	vec2 texCoords;
	vec2 blockTex;
} fragIn;

out vec4 color;

uniform sampler2DArray texSampler;
uniform float glow = 1.0;
uniform int side = 0;
uniform int blocksPerRow = 1;

void main() {
//	color = vec4(0, floor(fragIn.texCoords.x * 10) / 10.0, floor(fragIn.texCoords.y * 12) / 12.0, 1);
	if (side < 2) {
		float yy = (fragIn.texCoords.y * 2 - 1) / y60;
		float xx = fragIn.texCoords.x + yy * 0.25;
		yy = (yy + 1) * 0.5;
		float zz = yy - xx + 0.5;
		vec3 pp = vec3(xx, yy, zz) * 2 - 1;
		vec3 cc = 1 - abs(pp);
		int ss = 4;
		if (pp.x >= 0) {
			if (pp.z < 0) {
				if (pp.y >= 0) {
					cc = cc.zxy;
					ss = 0;
				} else {
					cc = cc.yzx;
					ss = 5;
				}
			} else ss = 1;
		} else {
			if (pp.z >= 0) {
				if (pp.y >= 0) {
					cc = cc.yzx;
					ss = 2;
				} else {
					cc = cc.zxy;
					ss = 3;
				}
			}
		}
		int size = textureSize(texSampler, 0).x;
		float factor = 1-cc.y;//(size - ceil(cc.y * size)) / size;
		int xInt = int(cc.x*size);
		int zInt = int(cc.z*size);
		float px = (xInt-zInt)/factor/size;
		vec2 tex = vec2(min(1 + px, 1), min(1 - px, 1)) * factor;
//		color = vec4(tex.y,0,0,1);//(floor(vec4(cc, 1) * size) / size).yzw);
		color = texture(texSampler, vec3(tex.s, tex.t, fragIn.blockTex.x * 6 + ss + (fragIn.blockTex.y * 3 + side * 2) * blocksPerRow));
//		color = vec4(tex.s,tex.t,0,1);
//		color = vec4(ceil(cc * size) / size, 1);
//		color = vec4(((1-cc.y) - ((size-ceil(cc.y*size))/size)) * size,0,0,1);
	} else {
		color = texture(texSampler, vec3(fragIn.texCoords, fragIn.blockTex.x * 6 + side - 2 + fragIn.blockTex.y * 3 * blocksPerRow));
	}
	color.rgb *= glow;
}