package hexagon;

import org.lwjgl.util.vector.Vector3f;

import hexagon.world.World;

public class HexBox {
	private final float radius;
	private final float height;
	private final Vector3f offset;
	
	public HexBox(float radius, float height, Vector3f offset) {
		this.radius = radius;
		this.height = height;
		this.offset = offset;
	}
	
	/** Assuming it doesn't already collide, will it collide after timeStep seconds? */
	public boolean willCollide(Vector3f _blockCoords, Vector3f _placeInBlock, Vector3f velocity, float timeStep, World world) {
		Vector3f placeInBlock = Vector3f.add(_placeInBlock, offset, null);
		Vector3f blockCoords = new Vector3f(_blockCoords);
		float diff = (int) (placeInBlock.x + 0.5f);
		blockCoords.x += diff;
		placeInBlock.x -= diff;
		diff = (int) (placeInBlock.y + 0.5f);
		blockCoords.y += diff;
		placeInBlock.y -= diff;
		diff = (int) (placeInBlock.z + 0.5f);
		blockCoords.z += diff;
		placeInBlock.z -= diff;
		
		return world.getBlock((int) blockCoords.x, (int) blockCoords.y - 1, (int) blockCoords.z) != null;
	}
}
