package hexagon.world.gen;

import java.util.Random;

public class NoiseGenOctaves {
	private final int octaves;
	private final NoiseGen[] noises;
	
	public NoiseGenOctaves(Random random, int octaves) {
		this.octaves = octaves;
		noises = new NoiseGen[octaves];
		for (int i = 0; i < octaves; i++) {
			noises[i] = new NoiseGen(random);
		}
	}
	
	public double genNoiseOctaves(double x, double y, double z) {
		double amplitude = 1;
		double result = 0;
		for (int i = 0; i < octaves; i++) {
			result += amplitude * noises[i].noise(x / amplitude, y / amplitude, z / amplitude);
			amplitude /= 2;
		}
		return result;
	}
}
