package hexagon.world;

import java.nio.ByteBuffer;
import java.nio.channels.FileChannel;

import hexagon.world.block.BlockType;

public class Block {
	
	public static final byte[][] neighbourOffsets = {
			{ 0, 1, 0},
			{ 0,-1, 0},
			{ 1, 0, 0},
			{ 0, 0, 1},
			{-1, 0, 1},
			{-1, 0, 0},
			{ 0, 0,-1},
			{ 1, 0,-1}
	};
	
	public final short coords;//in the chunk!
	protected Chunk chunk;
	public final BlockType blockType;
	protected byte sidesToRender;
	protected boolean willUpdate = false;
	
	public Block(int x, int y, int z, BlockType blockType, Chunk chunk) {
		this(Chunk.encodeCoords(x, y, z), blockType, chunk);
	}
	
	public Block(short coordsInChunk, BlockType blockType, Chunk chunk) {
		coords = coordsInChunk;
		this.blockType = blockType;
		this.chunk = chunk;
		sidesToRender = 0;
	}
	
	protected void saveBlock(ByteBuffer to, FileChannel fc) {
		if (to.remaining() < 4) chunk.cluster.world.saveBufferFull.accept(fc);
		to.putShort(coords);
		to.putShort(blockType.id);
	}
	
}
