#version 330 core
#define PI 3.14159265
#define y60 0.8660254

layout (triangles) in;
layout (triangle_strip, max_vertices = 3) out;

in VertOut {
	vec2 texCoords;
	int blockTex;
} vertOut[];

out FragIn {
	vec2 texCoords;
	vec2 blockTex;
} fragIn;

uniform mat4 projectionMatrix;
uniform mat4 viewMatrix;
//uniform float totalSize;
uniform float radius;
uniform vec3 cam;

void main() {
	vec2 blockTex = vec2(vertOut[0].blockTex & 0xffff, (vertOut[0].blockTex >> 16) & 0xffff);
	mat4 matrix = projectionMatrix * viewMatrix;
	for (int i = 0; i < 3; i++) {
		vec4 pos = vec4(gl_in[i].gl_Position.xyz, 1.0);
//		pos.xyz -= cam;
		pos.y += 5;
//		if (pos.y >= 5 || pos.y < -40 || isinf(pos.y) || isnan(pos.y)) pos.y = 5;
//		pos.x -= cam.x;
//		pos.y -= 0.001;
//		pos.z -= cam.z;
/*		pos.z = pos.z - cam.z / y60;
		float mult = exp((pos.y - cam.y) / radius);
		float v = pos.z * PI / totalSize;
		float z = -v;//-sin(v);
		float y = sqrt(1-z*z);//cos(v);
		float len = sqrt(z*z+y*y);
//		y /= len;
//		z /= len;
		pos = vec4(pos.x - cam.x, y * radius, z * radius, 0) * mult;
		pos.y -= radius;
		pos.w = 1;*/
		gl_Position = matrix * pos; // temp
		fragIn.texCoords = vertOut[i].texCoords;
		fragIn.blockTex = blockTex;
		EmitVertex();
	}
	EndPrimitive();
}