#version 330 core
#define y60 0.8660254

in FragIn {
	vec2 texCoords;
	vec2 blockTex;
} fragIn;

out vec4 color;

uniform sampler2DArray texSampler;
uniform float glow = 1.0;
uniform int side = 0;
uniform int blocksPerRow = 1;

void main() {
//	color = vec4(0, floor(fragIn.texCoords.x * 10) / 10.0, floor(fragIn.texCoords.y * 12) / 12.0, 1);
	if (side < 2) {
		float yy = (fragIn.texCoords.y * 2 - 1) / y60;
		float xx = fragIn.texCoords.x + yy * 0.25;
		yy = (yy + 1) * 0.5;
		float zz = yy - xx + 0.5;
		vec3 pp = vec3(xx, yy, zz) * 2 - 1;
		vec3 cc = 1 - abs(pp);
		int ss = 4;
		if (pp.x >= 0) {
			if (pp.z < 0) {
				if (pp.y >= 0) {
					cc = cc.zxy;
					ss = 0;
				} else {
					cc = cc.yzx;
					ss = 5;
				}
			} else ss = 1;
		} else {
			if (pp.z >= 0) {
				if (pp.y >= 0) {
					cc = cc.yzx;
					ss = 2;
				} else {
					cc = cc.zxy;
					ss = 3;
				}
			}
		}
		int size = textureSize(texSampler, 0).x;
		color = floor(vec4(cc, 1) * size) / size;
		float px = 1+floor(cc.x*size)/size-floor(cc.z*size)/size;
		vec2 tex = vec2(min(px, 1), 1-max(px - 1, 0)) * (1-ceil(cc.y*size)/size);
		color = texture(texSampler, vec3(tex.s, tex.t, fragIn.blockTex.x * 6 + ss + (fragIn.blockTex.y * 3 + side * 2) * blocksPerRow));
	} else {
		color = texture(texSampler, vec3(fragIn.texCoords, fragIn.blockTex.x * 6 + side - 2 + fragIn.blockTex.y * 3 * blocksPerRow));
	}
	color.rgb *= glow;
}