package hexagon.util;

import org.lwjgl.util.vector.Vector3f;

import hexagon.world.World;

public class Vec3f {
	
	private Vector3f eucl;
	private CylVec3 cyl;
	
	public Vec3f() {
		cyl = new CylVec3();
		eucl = new Vector3f();
	}
	
	public Vec3f(CylVec3 vec) {
		cyl = vec;
		cylToEuclCoords(vec, eucl = new Vector3f());
	}
	
	public void setCyl(CylVec3 src) {
		cyl.x = src.x;
		cyl.r = src.r;
		cyl.rv = src.rv;
		cylToEuclCoords(cyl, eucl);
	}
	
	public void setCyl(float x, double r, double v) {
		cyl.x = x;
		cyl.r = (float) r;
		v = MathUtil.superMod(v, Math.PI * 2);
		cyl.rv = (float) (r * v);
		cylToEuclCoords(cyl, eucl);
	}
	
	public Vector3f getEucl() {
		return eucl;
	}
	
	public CylVec3 getCyl() {
		return cyl;
	}
	
	public void updateEucl() {
		cyl.rv = (float) MathUtil.superMod(cyl.rv, Math.PI * 2 * cyl.r);
		cylToEuclCoords(cyl, eucl);
	}
	
	/** @param src where x = x, r = radius, v = angle */
	public static void cylToEuclCoords(CylVec3 src, Vector3f dest) {
		dest.x = src.x;
		dest.y = (float) (src.r * (Math.cos(src.rv / src.r)) - World.radius);
		dest.z = -(float) (src.r * Math.sin(src.rv / src.r));
	}
	
}
