package hexagon.world.block;

import gnu.trove.map.hash.TShortObjectHashMap;
import hexagon.model.HexagonModel;

public class BlockType {
	
	public static final BlockType grass, sand;
	public static TShortObjectHashMap<BlockType> blockTypes = new TShortObjectHashMap<>();
	
	static {
		int texID = HexagonModel.theModel.getTextureID();
		grass = new BlockType(1, texID, 0);
		sand = new BlockType(2, texID, 1 << 16);
	}
	
	public short id;
	public int texID;
	public int texCoords;
	
	public BlockType(int id, int texID, int texCoords) {
		this.id = (short) id;
		this.texID = texID;
		this.texCoords = texCoords;
		blockTypes.put(this.id, this);
	}
	
}
